<?php

/*
 * This file is part of the Jiannei/lumen-api-starter.
 *
 * (c) Jiannei <longjian.huang@foxmail.com>
 *
 * This source file is subject to the MIT license that is bundled
 * with this source code in the file LICENSE.
 */

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Repositories\Models\Course\Video;
use App\Repositories\Models\Inform\Category;
use App\Repositories\Models\Inform\Information;
use App\Repositories\Models\UserVideoWatchRecord;
use Carbon\Carbon;
use Jiannei\Response\Laravel\Support\Facades\Response;

class HomeController extends Controller
{
    public function index()
    {
        $admin = login_admin();
        $notices = Information::query()->whereIn('category_id', Category::byRoleGetIds($admin->role_id))->limit(3)->orderByDesc('id')->where('published_at', '<=', Carbon::now())->get();

        if ($admin->role_id == 1) {
            $video_ids = UserVideoWatchRecord::query()->where('user_id', $admin->id)->orderByDesc('updated_at')->limit(3)->pluck('video_id')->toArray();
            $courses = Video::query()->whereIn('id', $video_ids)->with(['course', 'course.thumb_resource', 'course_chapter'])->get();
        } else {
            $courses = Video::query()->where('admin_id', $admin->id)->with(['course', 'course.thumb_resource', 'course_chapter'])->limit(3)->orderByDesc('id')->get();
        }

        return Response::success(compact('notices', 'courses'));
    }
}
